function idx = GetVisibleForcPart(rho, Hc, Hu, maxHc, maxHu, options, minHc)
    if nargin < 7
        minHc = 0.003;
    end
    if nargin <= 5
        options = '';
    elseif isnumeric(options)
        minHc = options; 
        options = '';
    end
    if strcmpi(options, 'cropcorner')
        idx = logical(~isnan(rho) ...
                    & Hc-3*minHc>0 ...
                    & Hc-3*minHc>-Hu ...
                    & Hc<(maxHc-minHc)*0.95 ...
                    & abs(Hu)<maxHu*0.75);
        if ~any(idx)  
            idx = logical(~isnan(rho) ...
                    & Hc-minHc>0 ...
                    & Hc<maxHc-minHc ...
                    & abs(Hu)<maxHu*0.95);
        end
    elseif strcmpi(options, 'keepfirstpoint')
        dHc = diff(Hc);
        mHc = nanmean(dHc(:));
        idx = logical(~isnan(rho) ...
                    & Hc+2*mHc>=0 ...
                    & Hc<maxHc+2*mHc ...
                    & abs(Hu)<maxHu*0.95);
    else
        idx = logical(~isnan(rho) ...
                    & Hc-minHc>0 ...
                    & Hc<maxHc-minHc ...
                    & abs(Hu)<maxHu*0.95);
    end
end